//+------------------------------------------------------------------+
//|                                    .mq4 |
//+------------------------------------------------------------------+
#property copyright "  () 2008"
// -
//       
//          
//    ,       
//      

// !!!!          50000!!!

#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum 1
#property indicator_buffers 4
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_color1 Orange
#property indicator_color2 SteelBlue
#property indicator_color3 Orange
#property indicator_color4 SteelBlue
#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
#property indicator_style4 STYLE_SOLID

extern int TP=100;//    
extern int SL=50;//    

//----  
double BuyTP[];//,        
double BuySL[];//,        
double SellTP[];//,        
double SellSL[];//,        
double M2[];//   

//------------------------------------------------------------------- init
int init()
{
	IndicatorBuffers(5);
	SetIndexBuffer(0,BuyTP);	SetIndexStyle(0,DRAW_HISTOGRAM);	
	SetIndexBuffer(1,BuySL);	SetIndexStyle(1,DRAW_HISTOGRAM);
	SetIndexBuffer(2,SellTP);	SetIndexStyle(2,DRAW_HISTOGRAM);
	SetIndexBuffer(3,SellSL);	SetIndexStyle(3,DRAW_HISTOGRAM);
	SetIndexBuffer(4,M2);			SetIndexStyle(4,DRAW_NONE);				
	IndicatorShortName("  TP= "+TP+", SL= "+SL+" ");
	return(0);
}
//------------------------------------------------------------------- deinit
int deinit()  { return(0); }
//------------------------------------------------------------------- start
int start()
{
	int spread = MarketInfo(Symbol(), MODE_SPREAD); //   
	int i, k;
	double OpenPrice;
	bool find;
	//*********************************************************************************
	// 1.    1 -       
	//*********************************************************************************
	int z = IndicatorCounted(); if (z>0) z--;
	i=Bars-1-z;
	while (i>0)
	{
		//   ,        
		OpenPrice = Open[i]+spread*Point; //    
		k=i; find= false;
		while (k>=0 && !find) 
		{
			if (Low[k]<=OpenPrice-SL*Point) { BuyTP[i] = 0.0; BuySL[i] = 1.0; find = true; }//   
			else if (High[k]>=OpenPrice+TP*Point) { BuyTP[i] = 1; BuySL[i] = 0.0; find=true; } //   
			k--;
		}
		if (!find) { BuyTP[i] = 0.0; BuySL[i] = 0.0; }  //    ,      

		//   ,        
		OpenPrice = Open[i]; //    
		k=i; find=false;
		while (k>=0 && !find) 
		{
			if (High[k]>=OpenPrice+(SL+spread)*Point) { SellTP[i] = 0.0; SellSL[i] = -1.0; find = true; }//   
			else if (Low[k]<=OpenPrice-(TP+spread)*Point) { SellTP[i] = -1.0; SellSL[i] = 0.0; find=true; } //   
			k--;
		}
		if (!find) { SellTP[i] = 0.0; SellSL[i] = 0.0; } //    ,      
		i--;
	}
	//****************************************************************************
	// 2.            2
	//    MACD
	//****************************************************************************
	int FastEMA=12;
	int SlowEMA=26;
	int SignalMA=9;
	int Price=PRICE_CLOSE;
	double main0, sign0, main1, sign1;
	i=Bars-1;
	while (i>0)
	{
		M2[i]=0.0;
		main0 = iMACD(NULL, 0, FastEMA, SlowEMA, SignalMA, Price, MODE_MAIN, i);
		main1 = iMACD(NULL, 0, FastEMA, SlowEMA, SignalMA, Price, MODE_MAIN, i-1);
		sign0 = iMACD(NULL, 0, FastEMA, SlowEMA, SignalMA, Price, MODE_SIGNAL, i);
		sign1 = iMACD(NULL, 0, FastEMA, SlowEMA, SignalMA, Price, MODE_SIGNAL, i-1);
		if (main0>sign0 && main1<sign1)	M2[i]=1.0;//    
		else if (main0<sign0 && main1>sign1)	M2[i]=-1.0;//    
		i--;
	}
	//**********************************************************************************
	// 3.    1  2.    
	//**********************************************************************************
	//   
	int nBuy=0, nSell=0, N=0, nBuyTP=0, nBuySL=0, nSellTP=0, nSellSL=0;
	i=Bars-1;
	while (i>0)
	{
		if (BuyTP[i]>0) nBuyTP++;//     
		if (BuySL[i]>0) nBuySL++;//     
		if (SellTP[i]<0) nSellTP++;//     
		if (SellSL[i]<0) nSellSL++;//     
		//   /
		if (M2[i]==1.0 && BuyTP[i-1]==1.0)	nBuy++;//       
		if (M2[i]==-1.0 && SellTP[i-1]==-1.0)	nSell++;//       
		if (M2[i]!=0.0 && (BuySL[i-1]==-1.0 || SellSL[i-1]==-1.0))	N++;//   
		i--;
	}
	//  
	string st="\n";
	st = st+ "= "+TP+",  =  "+SL+"\n";
	st = st+ ": -     "+ nBuyTP +",     " + nBuy +"\n";
	st = st+ ": -     "+ nSellTP +",     " + nSell+"\n";
	st = st+ ": -    "+ (nBuySL+nSellSL) +",     " + N+"\n";
	st = st+ ": " + ((nBuy+nSell)*TP-(N*SL)) + "  \n";
	Comment(st);
	return(0);
}
//+----------------------------------------------------------------------------------+